#include "xslt.h"
const char *xslt_library = 
"<?xml version=\"1.0\"?>\n"
"<xsl:stylesheet	xmlns:xsl=\"http://www.w3.org/1999/XSL/Transform\" \n"
"				xmlns:swft=\"http://subsignal.org/swfml/swft\"\n"
"				extension-element-prefixes=\"swft\"\n"
"				version='1.0'>\n"
"\n"
"<xsl:output method=\"xml\" indent=\"yes\"/>\n"
"\n"
"<!-- basic SWF setup -->\n"
"<xsl:template match=\"files\">\n"
"	<!-- set defaults for movie -->\n"
"	<xsl:variable name=\"version\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@version\"><xsl:value-of select=\"@version\"/></xsl:when>\n"
"			<xsl:otherwise>7</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"compressed\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@compressed\"><xsl:value-of select=\"@compressed\"/></xsl:when>\n"
"			<xsl:otherwise>1</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"framerate\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@framerate\"><xsl:value-of select=\"@framerate\"/></xsl:when>\n"
"			<xsl:otherwise>12</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"frames\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@frames\"><xsl:value-of select=\"@frames\"/></xsl:when>\n"
"			<xsl:otherwise>1</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"left\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@left\"><xsl:value-of select=\"@left\"/></xsl:when>\n"
"			<xsl:otherwise>0</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"top\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@top\"><xsl:value-of select=\"@top\"/></xsl:when>\n"
"			<xsl:otherwise>0</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"right\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@right\"><xsl:value-of select=\"@right\"/></xsl:when>\n"
"			<xsl:otherwise>6400</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"bottom\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@bottom\"><xsl:value-of select=\"@bottom\"/></xsl:when>\n"
"			<xsl:otherwise>4800</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"red\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@red\"><xsl:value-of select=\"@red\"/></xsl:when>\n"
"			<xsl:otherwise>255</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"green\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@green\"><xsl:value-of select=\"@green\"/></xsl:when>\n"
"			<xsl:otherwise>255</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"	<xsl:variable name=\"blue\">\n"
"		<xsl:choose>\n"
"			<xsl:when test=\"@blue\"><xsl:value-of select=\"@blue\"/></xsl:when>\n"
"			<xsl:otherwise>255</xsl:otherwise>\n"
"		</xsl:choose>\n"
"	</xsl:variable>\n"
"\n"
"	<swf version=\"{$version}\" compressed=\"{$compressed}\">\n"
"		<Header framerate=\"{$framerate}\" frames=\"{$frames}\">\n"
"			<size>\n"
"				<Rectangle left=\"{$left}\" right=\"{$right}\" top=\"{$top}\" bottom=\"{$bottom}\"/>\n"
"			</size>\n"
"			<tags>\n"
"				<SetBackgroundColor>\n"
"					<color>\n"
"						<Color red=\"{$red}\" green=\"{$green}\" blue=\"{$blue}\"/>\n"
"					</color>\n"
"				</SetBackgroundColor>\n"
"				\n"
"				<xsl:apply-templates/>\n"
"				\n"
"				<ShowFrame/>\n"
"				<End/>\n"
"			</tags>\n"
"		</Header>\n"
"	</swf>\n"
"</xsl:template>\n"
"\n"
"<!-- JPEG import -->\n"
"<!-- <jpeg file=\"myjpeg.jpg\" name=\"foo\" width=\"640\" height=\"480\"/> -->\n"
"<xsl:template match=\"jpeg\">\n"
"	<xsl:variable name=\"bitmapID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	<xsl:variable name=\"shapeID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	<xsl:variable name=\"spriteID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	<DefineBitsJPEG2 import=\"{@file}\" objectID=\"{$bitmapID}\"/>\n"
"	<DefineShape objectID=\"{$shapeID}\">\n"
"		<bounds>\n"
"			<Rectangle left=\"0\" right=\"{@width}\" top=\"0\" bottom=\"{@width}\"/>\n"
"		</bounds>\n"
"		<styles>\n"
"			<StyleList>\n"
"				<fillStyles>\n"
"					<ClippedBitmap objectID=\"{$bitmapID}\">\n"
"						<matrix>\n"
"							<Transform transX=\"0\" transY=\"0\"/>\n"
"						</matrix>\n"
"					</ClippedBitmap>\n"
"				</fillStyles>\n"
"				<lineStyles/>\n"
"			</StyleList>\n"
"		</styles>\n"
"		<shapes>\n"
"			<Shape>\n"
"				<edges>\n"
"					<ShapeSetup x=\"{@width}\" y=\"{@height}\" fillStyle1=\"1\"/>\n"
"					<LineTo x=\"-{@width}\" y=\"0\"/>\n"
"					<LineTo x=\"0\" y=\"-{@height}\"/>\n"
"					<LineTo x=\"{@width}\" y=\"0\"/>\n"
"					<LineTo x=\"0\" y=\"{@height}\"/>\n"
"					<ShapeSetup/>\n"
"				</edges>\n"
"			</Shape>\n"
"		</shapes>\n"
"	</DefineShape>\n"
"	<DefineSprite objectID=\"{$spriteID}\" frames=\"1\">\n"
"		<tags>\n"
"			<PlaceObject2 replace=\"0\" depth=\"1\" objectID=\"{$shapeID}\">\n"
"				<transform>\n"
"					<Transform transX=\"0\" transY=\"0\" scaleX=\"20\" scaleY=\"20\"/>\n"
"				</transform>\n"
"			</PlaceObject2>\n"
"			<ShowFrame/>\n"
"			<End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<Export count=\"1\">\n"
"		<symbols>\n"
"			<Symbol objectID=\"{$spriteID}\" name=\"{@name}\"/>\n"
"		</symbols>\n"
"	</Export>\n"
"	\n"
"	<!-- also place the object, should not be done lateron \n"
"	<PlaceObject2 replace=\"0\" depth=\"{$spriteID}\" objectID=\"{$spriteID}\">\n"
"		<transform>\n"
"			<Transform transX=\"0\" transY=\"0\"/>\n"
"		</transform>\n"
"	</PlaceObject2>\n"
"	-->\n"
"</xsl:template>\n"
"\n"
"<xsl:template match=\"swf\">\n"
"	<swft:reset-map/>\n"
"	<xsl:apply-templates select=\"swft:document(@file)\" mode=\"sprite\">\n"
"		<xsl:with-param name=\"name\"><xsl:value-of select=\"@name\"/></xsl:with-param>\n"
"	</xsl:apply-templates>\n"
"</xsl:template>\n"
"\n"
"<!-- matches the imported document -->\n"
"<xsl:template match=\"swf\" mode=\"sprite\">\n"
"	<xsl:param name=\"name\"/>\n"
"	<xsl:variable name=\"swfID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	<xsl:variable name=\"spriteID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	\n"
"	<xsl:apply-templates select=\"Header/tags/*\" mode=\"sprite-global\"/>\n"
"		\n"
"	<DefineSprite objectID=\"{$swfID}\" frames=\"{count(Header/tags/ShowFrame)}\">\n"
"		<tags>\n"
"			<xsl:apply-templates select=\"Header/tags/*\" mode=\"sprite-local\"/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<DefineSprite objectID=\"{$spriteID}\" frames=\"1\">\n"
"		<tags>\n"
"			<PlaceObject2 replace=\"0\" depth=\"1\" objectID=\"{$swfID}\">\n"
"				<transform>\n"
"					<Transform transX=\"0\" transY=\"0\" />\n"
"<!--						scaleX=\"{( Header/size/Rectangle/@right - Header/size/Rectangle/@left ) * 20}\" \n"
"						scaleY=\"{( Header/size/Rectangle/@bottom - Header/size/Rectangle/@top ) * 20}\"\n"
"-->\n"
"				</transform>\n"
"			</PlaceObject2>\n"
"			<ShowFrame/>\n"
"			<End/>\n"
"		</tags>\n"
"	</DefineSprite>\n"
"	<Export count=\"1\">\n"
"		<symbols>\n"
"			<Symbol objectID=\"{$spriteID}\" name=\"{$name}\"/>\n"
"		</symbols>\n"
"	</Export>\n"
"	<!-- also place the object, should not be done lateron \n"
"	<PlaceObject2 replace=\"0\" depth=\"{$spriteID}\" objectID=\"{$spriteID}\">\n"
"		<transform>\n"
"			<Transform transX=\"0\" transY=\"0\"/>\n"
"		</transform>\n"
"	</PlaceObject2>\n"
"	-->\n"
"</xsl:template>\n"
"\n"
"<!-- global id remapping -->\n"
"<xsl:template match=\"@objectID\" mode=\"idmap\">\n"
"	<xsl:attribute name=\"objectID\"><xsl:value-of select=\"swft:map-id(.)\"/></xsl:attribute>\n"
"</xsl:template>\n"
"<xsl:template match=\"*|@*|text()\" mode=\"idmap\" priority=\"-1\">\n"
"	<xsl:copy select=\".\">\n"
"		<xsl:apply-templates select=\"*|@*|text()\" mode=\"idmap\"/>\n"
"	</xsl:copy>\n"
"</xsl:template>\n"
"\n"
"<!-- for tags that are \"globalized\" -->\n"
"<xsl:template match=\"SetBackgroundColor\" mode=\"sprite-global\"/>\n"
"<xsl:template match=\"DoAction|End|FrameLabel|PlaceObject|PlaceObject2|RemoveObject|RemoveObject2|ShowFrame|SoundStreamBlock|SoundStreamHead|StartSound\" mode=\"sprite-global\"/>\n"
"<xsl:template match=\"*|@*|text()\" mode=\"sprite-global\" priority=\"-1\">\n"
"	<xsl:apply-templates select=\".\" mode=\"idmap\"/>\n"
"</xsl:template>\n"
"\n"
"<!-- for tags that move into the DefineSprite -->\n"
"<xsl:template match=\"DoAction|End|FrameLabel|PlaceObject|PlaceObject2|RemoveObject|RemoveObject2|ShowFrame|SoundStreamBlock|SoundStreamHead|StartSound\" mode=\"sprite-local\">\n"
"	<xsl:apply-templates select=\".\" mode=\"idmap\"/>\n"
"</xsl:template>\n"
"<xsl:template match=\"*|@*|text()\" mode=\"sprite-local\" priority=\"-1\"/>\n"
"\n"
"\n"
"<!-- FONT import -->\n"
"<!-- <font file=\"myfont.ttf\" name=\"myfont\"/> -->\n"
"<xsl:template match=\"font\">\n"
"	<xsl:variable name=\"fontID\"><xsl:value-of select=\"swft:next-id()\"/></xsl:variable> \n"
"	<DefineFont2 objectID=\"{$fontID}\" name=\"{@name}\" import=\"{@file}\"\n"
"				isShiftJIS=\"0\" isUnicode=\"1\" isANSII=\"0\" wideGlyphOffsets=\"0\" \n"
"				italic=\"0\" bold=\"0\" language=\"1\"	\n"
"				/>\n"
"	<Export count=\"1\">\n"
"		<symbols>\n"
"			<Symbol objectID=\"{$fontID}\" name=\"{@name}\"/>\n"
"		</symbols>\n"
"	</Export>\n"
"</xsl:template>\n"
"\n"
"</xsl:stylesheet>\n"
;
